!**************************
      function nrighe_file(filename)

      implicit none
      character(*),intent(in)::filename
      integer::stat_read,nrighe_file

      open (415,file=filename,iostat=stat_read,status='old')  !apre name

      nrighe_file=0
      if (stat_read==0) then
      do
        read(415,*,iostat=stat_read) 
        if (stat_read < 0) exit  !end of file  
        nrighe_file=nrighe_file+1
      enddo
      close (415)
      endif

      end function nrighe_file


!**********
      function skip_lines_in_file(unit,rem)
      ! salta righe nel'unita' unit fintantoche' cominciano con uno
      ! dei caratteri della stringa rem. Restituisce numero righe saltate
      implicit none
      integer::unit
      character(*):: rem
      character(1)::first
      integer:: skip_lines_in_file

      skip_lines_in_file=0
      first=rem(1:1)

      do while (scan(first,rem)/=0) 
        read(unit,*,err=999,end=999) first
        skip_lines_in_file=skip_lines_in_file+1 
      enddo
      backspace(unit)
	skip_lines_in_file=skip_lines_in_file-1 

999   continue
      end function skip_lines_in_file

*-----------------------------------------------------------------------
      SUBROUTINE INPBAN
*     LEGGE GLI ARRAYS DEL SISTEMA FOTOMETRICO
      use modname       
      use globande

      implicit none

      integer::i,ispl,iban,stat_read
      real:: tmp
      character(len=90):: file_bande

! inizio file bande.dat:

!# UBVRI NORMALIZED STANDARD PASSBANDS da Bessel 1990, PASP, 102, 1181, Table 2
!# JHKLM                               da Bessel & Brett 1988, PASP, 100, 1134, Table IV (senza errori!) 
!# flussi a mag 0 in erg/cm^2/s/A dalla tesi di Gian
!#   lUX      UX      lBX     BX      lB       B      lV        V      lR     R     lJ    J     lH    H     lK   K      lL   L      lM   M
!   3.697e-9         6.635e-9        6.635e-9        3.673e-9        2.256e-9       3.029e-10   1.260e-10   4.134e-11   6.894e-12   2.213e-12
!    0.300   0.000   0.360   0.000   0.360   0.000   0.470   0.000   0.550   0.00  1.04 0.00   1.46 0.00   1.94 0.00   3.04 0.00   4.44 0.00
!    0.305   0.016   0.370   0.026   0.370   0.030   0.480   0.030   0.560   0.23  1.06 0.02   1.48 0.15   1.96 0.12   3.08 0.02   4.48 0.13
!    0.310   0.068   0.380   0.120   0.380   0.134   0.490   0.163   0.570   0.74  1.08 0.11   1.50 0.44   1.98 0.20   3.12 0.09   4.52 0.34

! UX e BX sono fatte apposta per U-B; la mag U da sola non e' reliable. Per la B da sola
! si usano lB e B

      file_bande=trim(name_dir)//'bande.dat'      

      OPEN(10,FILE=file_bande,iostat=stat_read,status='old')

      if (stat_read==0) then
           read(10,'(///)')              !salta 4 righe
           READ(10,*) (ZP(I),I=1,NBAN)   !flussi a mag 0 in erg/cm^2/s/A 
	     do ISPL=1,NSPL
		    READ(10,*) (WL(ISPL,IBAN),TRA(ISPL,IBAN),IBAN=1,NBAN)
			!write(*,*) ispl, stat_read
           enddo
           WL=WL*1.e4    !lavoro con lamda in A e flussi in ergs/cm^2/s/A
      else
           write(*,*) 'errore in open file bande', stat_read 
      endif

      CLOSE(10)

      END SUBROUTINE INPBAN
*-----------------------------------------------------------------------
      SUBROUTINE INPSPE

      use modname
      use parametri, only:nopt,redshift,omega,H_o,lambda,rest
      use gloinpspe
      implicit none
      integer::i, err_alloc, stat_read 
      integer:: nrighe_file
      real:: tmp,z
      integer::skip_lines_in_file
      real, parameter:: pi=3.1415926

      npp=nrighe_file(name)  
	print *, npp
      OPEN(30,FILE=name,iostat=stat_read,status='old')
      npp=npp-skip_lines_in_file(30,'#')
	print *, npp
      !con i vecchi files di grasil e vegahs.spe skip_lines_in_file(30,'#')
      !e' 1, con i nuovi e' 15
      allocate(wlpp(npp),iwlpp(npp),wl2(npp),iwl2(npp),STAT=ERR_ALLOC)
      IF (ERR_ALLOC /= 0) THEN
          PRINT *, "ALLOCATION ERROR in INPSPE"
          STOP
      ENDIF
      wlpp=0.; iwlpp=0. ; wl2=0. ; iwl2=0.


      if (stat_read==0) then
          if (name=='vegahs.spe') then
              do I=1,npp
		       READ(30,*) WLPP(I),IWLPP(I)
              enddo
              WLPP=WLPP*1E4
	        IWLPP=IWLPP*1E-12 !passo a A e ergs/cm^2/s/A (da mu e 1e-15 W/cm^2/mu)
 
          else if (name=='SED_SSP.out') then
              do I=1,npp
		       READ(30,*) WLPP(I),IWLPP(I)
              enddo
             !gli spettri di input sono luminosita' in erg/s/A/10^30/Msun
             !calcolo le mags assolute moltiplicando per 10^30/(4*pi*d(10pc)^2)
             IWLPP=IWLPP*8.3577e-11   !erg/cm^2/s/A

		else
              do I=1,npp
		       READ(30,*) WLPP(I),tmp,tmp,tmp,tmp,IWLPP(I)
              enddo
			wl2=wlpp ; iwl2=iwlpp
			iwl2=iwl2*wl2/3e18*wl2 ; wl2=3e18/wl2  

	        if (nopt>0 .and. redshift>0.) then
	           z=redshift
                 !F_lam_oss=L_lam_em/(4*pi*d_lum^2)/(1+z) 
	           !v. Quasar Astronomy p.61 in fondo
	           tmp=d_lum(z)
	           if (.not.rest) then

                    WLPP=WLPP*(1+z) !redshifto le lambda se non lavoro nel rest frame
	              !gli spettri di input sono luminosita' in erg/s/A/10^30
                    IWLPP=IWLPP/tmp*1e30/tmp/(4*pi)/(1+z)  !erg/cm^2/s/A   
			      iwl2=iwl2/tmp*1e30/tmp/(4.*pi)*(1.+z)
				  	  				 								  				  				                   
	           else  !se lavoro nel rest frame solo mag assolute
	              !gli spettri di input sono luminosita' in erg/s/A/10^30
	              !calcolo le mags assolute moltiplicando per 10^30/(4*pi*d(10pc)^2)
	              IWLPP=IWLPP*8.3577e-11   !erg/cm^2/s/A
			   endif
	        else
	            !gli spettri di input sono luminosita' in erg/s/A/10^30
	            !calcolo le mags assolute moltiplicando per 10^30/(4*pi*d(10pc)^2)
	            IWLPP=IWLPP*8.3577e-11   !erg/cm^2/s/A
	        endif
	    endif
      else
          write(*,*) 'errore in open file spettro', stat_read 
      endif


      CLOSE(30)
    !*************

      contains

        real function d_lum(z)
	  use nr90_gian
	  implicit none   
        !dato z, Ho, omega e in caso lambda da' la distanza di luminosita' in cm
	  !v. review De Zotti et al 1996, (4)
        !c/Ho = 9.257e29/Ho cm con Ho in km/s/Mpc
        integer,parameter::nz=100
        real,dimension(nz), save:: z_arr, d_arr
        logical,save::first_call=.true.
        real::z,wk
	  integer::k

	  if (lambda == 0) then 
        ! no cosmological constant, analytic expression
           d_lum=9.257e29/H_o*z*
     @     ( 1 + z*(2-omega)/( 2+omega*z+2*sqrt(1+omega*z) ) )
	  else
        ! on first call compute values for interpolation
           if (z>100) then
             write(*,*) 'errore in d_lum' 
           endif
           if (first_call) then
              z_arr=(/(10**(-2+(k-1)*4.0/(nz-1)),k=1,nz)/); z_arr(1)=0
              d_arr=(/(dis_lum_lambda(z_arr(k)),k=1,nz)/) 
              first_call=.false.
           endif
	     call liin(z_arr,d_arr,z,wk)
           d_lum=9.257e29/H_o*wk
	  endif
	  
	  end function d_lum

      !**********

        function dis_int(zz)
        ! function to be integrated to get the luminosity distance 
        ! of the universe for models with a cosmological constant
        implicit none
        real,dimension(:),intent(in):: zz
        real,dimension(size(zz)):: dis_int,upz
        !real,intent(in):: zz
        !real:: dis_int,upz

        upz=1+zz
        dis_int = (upz*upz*(omega*zz+1)-zz*(2+zz)*lambda)**(-0.5) 

        end function dis_int
 
      !**********
      function dis_lum_lambda(z)
      ! luminosity distance for Lambda universe in units of c/Ho
      use nr90_gian,only:qromb_eps
      implicit none
      real:: dis_lum_lambda,z,t3,omega_k,wk

      omega_k=1-lambda-omega
      t3=sqrt(abs(omega_k))
      !call qromb(dis_int,0.0,z,wk,1e-4)
	wk=qromb_eps(dis_int,0.0,z,1e-6)
      if (omega_k>0.001) then
         wk=sinh(t3*wk)/t3
      else if (omega_k<-0.001) then
         wk=sin(t3*wk)/t3
      endif
      ! wk now is the proper motion distance
      dis_lum_lambda = (1+z)*wk

      end function dis_lum_lambda

      !***********

      END SUBROUTINE INPSPE

*-----------------------------------------------------------------------
	SUBROUTINE INISPL(IBAN)
*	TRASFERISCE GLI ELEMENTI DEGLI ARRAYS RELATIVI ALLA BANDA IBAN
*	DAGLI ARRAYS WL,TRA A X,Y. 

      use globande, only: WL, TRA, X, Y, nspl

	implicit none

      integer,intent(in)::iban
	integer::ispl

	DO  ISPL=1,NSPL
		X(ISPL)=WL(ISPL,IBAN)
		Y(ISPL)=TRA(ISPL,IBAN)
      ENDDO

	END SUBROUTINE INISPL

*-----------------------------------------------------------------------

*___________________________________________________


!*********************************

      subroutine outcolevol

      use globande, only:CI, BAN, mag, nban
	use parametri, only:redshift, omega,H_o, lambda, rest
	use gloinpspe, only:n_lam,lam_arr,Lnu_arr

	implicit none
	integer,parameter::ncol=9
	CHARACTER(len=3),dimension(ncol):: 
     @COL=(/'U-B','B-V','V-R','R-I','I-J','J-H','H-K','K-L','L-M'/)
      integer::i

      open(10,file='colevol.out')
      write(10,10) H_o, omega, lambda
 10   format('#',' Ho=', f3.0, ' Omega=', f3.1, ' Lambda=', f3.1)

	write(10,11) COL  
 11   format('#','  z',10(4x,a5)) 

	write(10,'(1x,f4.2,10(1x,f8.3))') 
     @redshift, ci(1,2), ci(3,4), ci(4,5), ci(5,6), ci(6,7), 
     @ci(7,8), ci(8,9), ci(9,10), ci(10,11) 

	write(10,12) BAN(1),(BAN(i),i=3,nban), (lam_arr(i),i=1,n_lam) !UX B V R I J H K L M  
 12   format('#','  z',10(4x,a5),5(5x,f6.0),'  mJy') 
 
	write(10,'(1x,f4.2,10(1x,f8.3),5(1x,1pe11.3))') 
     @redshift, mag(1), (mag(i),i=3,nban), (10**Lnu_arr(i),i=1,n_lam)

	close(10)

      end subroutine outcolevol

!***********************************

      subroutine outcoltab

      use modname, only:name
      use globande, only:CI, mag, ban, nban, Lbanda 
	implicit none
      character(len=80)::fileout
	integer::i,j, iban

	fileout='col'//name

	OPEN(100,FILE=fileout)
	WRITE(100,'(5X,30(8X,A2))')(BAN(I),I=1,NBAN)
	WRITE(100,'(5X,30(3X,f7.3))')(mag(I),I=1,NBAN)
      write(100,'(/)')

	WRITE(100,185)(BAN(I),I=NBAN,2,-1)
	WRITE(100,195)
 185  FORMAT(5X,30(8X,A2))
 195	FORMAT
     *('    =======================================================',
     *      '===================================')

	DO I=1,NBAN-1
		WRITE(100,205) BAN(I),(CI(I,J),J=NBAN,I+1,-1)
 205	    FORMAT(1X,A2,' -|',100F10.3)
	enddo
      write(100,'(/)')
	write(100,*) 'Per U-B guardare UX-BX'
	write(100,*) 'luminosita integrate in banda (1e30 erg/s/A)'
	WRITE( 100, '(5X,30(1pe11.3))'  ) (Lbanda(I),I=1,NBAN)
	CLOSE(100)

      end subroutine outcoltab

*-----------------------------------------------------------------------
!	REAL FUNCTION FLU_OLD(WL)
!C	SPETTRO COMPLESSIVO IN FUNZIONE DELLA LUNGHEZZA D'ONDA IN A
!C	MOLTIPLICATO PER LA TRASMISSIONE DEL SISTEMA FOTOMETRICO
!! lo tengo perche' potrebbe essere utile. pero' se si usa 
!! questo flusso, hanno senso solo i colori perche' si usano
!! flussi nomalizzati
!
!      use glo_flu_old
!	use gloinpspe, only: npp
!	implicit none
!	real, intent(in)::wl
!      real::pp,sisfot   
!	integer:: fir_cal=0
!
!	if (fir_cal==0) then
!         fir_cal=1
!	   CALL INPPAR   
!	   CBB=CBB/BB(WLCF)
!	   CPL=CPL/PL(WLCF)
!	   IF (NPP.GT.1) CPP=CPP/PP(WLCF)
!      endif
!
!	FLU_OLD=(CBB*BB(WL)+CPL*PL(WL)+CPP*PP(WL))*SISFOT(WL)
!
!      !****************
!
!      contains  
!
!	  SUBROUTINE INPPAR
!	  implicit none
!
!	  OPEN(20,FILE='CI.PAR')
!	  READ (20,10) TBB,ALPHA,WLCF,CBB,CPL,CPP
!10	  FORMAT(F10.3,/,F10.3,/,F10.3,/,F10.3,/,F10.3,/,F10.3)
!	  CLOSE(20)
!
!        !CI.PAR :
!        !1500.0  Temperatura black body
!        !-1.50   Indice spettrale in frequenza
!        !1.00    WLCF di confronto
!        !0.00    Peso black body
!        !0.00    Peso power law
!        !1.00    Peso per punti
!
!	  END SUBROUTINE INPPAR
!      !****************
!
!        REAL FUNCTION BB(WL)
!!	  SPETTRO PLANCKIANO DI CORPO NERO A TEMPERATURA TBB
!!	  (A MENO DI UN'INESSENZIALE COSTANTE MOLTIPLICATIVA)
!!	  IN FUNZIONE DELLA LUNGHEZZA D'ONDA IN MICRONS
!
!        implicit none
!
!	  real,parameter::C2=1.43883E+4
!        real, intent(in):: wl
!	  real:: wl5,arg
!
!	  WL5=WL*WL*WL*WL*WL
!	  ARG=C2/WL/TBB
!	  IF (ARG.LT.40) THEN
!		 BB=1/WL5/(EXP(ARG)-1)
!	  ELSE
!	     BB=1E-20
!	  ENDIF
!
!	  END FUNCTION BB
      !****************

!	  REAL FUNCTION PL(WL)
!	  SPETTRO A LEGGE DI POTENZA DI INDICE SPETTRALE ALPHAIN FREQUENZA
!	  (F=K*NU**ALPHA) IN FUNZIONE DELLA LUNGHEZZA D'ONDA IN MICRONS

!        implicit none
!        real, intent(in)::wl

!	  PL=WL**(-2-ALPHA)

!	  END FUNCTION PL


      !****************

!	END FUNCTION FLU_OLD

!****************************************
